var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b ||= {})
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __objRest = (source, exclude) => {
  var target = {};
  for (var prop in source)
    if (__hasOwnProp.call(source, prop) && exclude.indexOf(prop) < 0)
      target[prop] = source[prop];
  if (source != null && __getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(source)) {
      if (exclude.indexOf(prop) < 0 && __propIsEnum.call(source, prop))
        target[prop] = source[prop];
    }
  return target;
};

// src/route/select.tsx
import React2, { memo as memo2 } from "react";

// src/common/routeHooks.ts
import { useSearchParams } from "react-router-dom";
function useRouteSelect(options, filterName, emptyValue) {
  const [searchParams, setSearchParams] = useSearchParams();
  const optionValues = searchParams.getAll(filterName);
  const selectedOptions = options.filter((x) => optionValues.includes(x.value));
  const onChange = (option) => {
    searchParams.delete(filterName);
    if (option) {
      if (Array.isArray(option)) {
        option.forEach((x) => {
          searchParams.append(filterName, x.value);
        });
      } else {
        searchParams.set(filterName, option.value);
      }
    } else if (emptyValue) {
      searchParams.set(filterName, "");
    }
    setSearchParams(searchParams, { replace: true });
  };
  return {
    selectedOptions,
    onChange
  };
}

// src/select.tsx
import classNames from "classnames";
import React, { Fragment, memo } from "react";
import { Listbox, Transition } from "@headlessui/react";
import {
  CheckIcon,
  ChevronDownIcon,
  XMarkIcon
} from "@heroicons/react/20/solid";
function Select({
  className,
  options,
  selectedOption,
  selectedOptions,
  onChange,
  multiple,
  placeholder,
  isLoading,
  filter,
  resetButton = true
}) {
  const selectedValue = multiple ? selectedOptions : selectedOption;
  const selectedLabel = multiple ? selectedOptions == null ? void 0 : selectedOptions.map((x) => x.label).join(", ") : selectedOption == null ? void 0 : selectedOption.label;
  return /* @__PURE__ */ React.createElement(
    Listbox,
    {
      value: selectedValue || null,
      onChange,
      multiple,
      as: "div",
      className: classNames("relative", className)
    },
    /* @__PURE__ */ React.createElement(
      Listbox.Button,
      {
        className: classNames(
          "relative form-control h-9 cursor-default py-2 pl-3 pr-10 text-left text-sm",
          filter ? "form-filter" : ""
        )
      },
      /* @__PURE__ */ React.createElement(
        "span",
        {
          title: selectedLabel,
          className: classNames(
            "block truncate",
            selectedLabel ? "" : "text-secondary-500"
          )
        },
        selectedLabel || placeholder
      ),
      (!resetButton || !selectedLabel) && /* @__PURE__ */ React.createElement("span", { className: "pointer-events-none absolute inset-y-0 right-2 flex items-center" }, /* @__PURE__ */ React.createElement(
        ChevronDownIcon,
        {
          className: "h-5 w-5 text-secondary-500",
          "aria-hidden": "true"
        }
      ))
    ),
    resetButton && selectedLabel && /* @__PURE__ */ React.createElement(
      "button",
      {
        type: "button",
        className: "absolute z-10 right-2.5 inset-y-0 my-auto h-5 px-0.5 rounded hover:bg-secondary-100 active:bg-secondary-200 focus:outline-none focus-visible:ring-2 focus-visible:ring-primary-500",
        onClick: () => {
          if (multiple) {
            onChange([]);
          } else {
            onChange(null);
          }
        }
      },
      /* @__PURE__ */ React.createElement(
        XMarkIcon,
        {
          className: "h-4 w-4 text-secondary-500",
          "aria-hidden": "true"
        }
      )
    ),
    /* @__PURE__ */ React.createElement(
      Transition,
      {
        as: Fragment,
        leave: "transition ease-in duration-100",
        leaveFrom: "opacity-100",
        leaveTo: "opacity-0"
      },
      /* @__PURE__ */ React.createElement(Listbox.Options, { className: "absolute z-40 mt-1 w-full rounded-md bg-white py-1 shadow-lg ring-1 ring-black ring-opacity-5 focus:outline-none text-sm" }, options.length === 0 || isLoading ? /* @__PURE__ */ React.createElement("div", { className: "relative cursor-default select-none py-2 px-4 text-secondary-700" }, isLoading ? "Loading..." : "No options") : /* @__PURE__ */ React.createElement("div", { className: "overflow-auto max-h-60" }, options.map((option) => /* @__PURE__ */ React.createElement(
        Listbox.Option,
        {
          key: option.value,
          className: ({ active }) => `relative cursor-default select-none py-2 pl-10 pr-4 ${active ? "bg-primary-100 text-primary-900" : "text-secondary-900"}`,
          value: option
        },
        ({ selected }) => /* @__PURE__ */ React.createElement(React.Fragment, null, /* @__PURE__ */ React.createElement(
          "span",
          {
            className: `block truncate ${selected && selectedValue ? "font-medium" : "font-normal"}`
          },
          option.label
        ), selected && selectedValue ? /* @__PURE__ */ React.createElement("span", { className: "absolute inset-y-0 left-0 flex items-center pl-3 text-primary-600" }, /* @__PURE__ */ React.createElement(CheckIcon, { className: "h-5 w-5", "aria-hidden": "true" })) : null)
      ))))
    )
  );
}
var select_default = memo(Select);

// src/route/select.tsx
function RouteSelect(_a) {
  var _b = _a, {
    options,
    filterName,
    emptyValue,
    multiple
  } = _b, rest = __objRest(_b, [
    "options",
    "filterName",
    "emptyValue",
    "multiple"
  ]);
  const { onChange, selectedOptions } = useRouteSelect(options, filterName, emptyValue);
  if (multiple) {
    return /* @__PURE__ */ React2.createElement(
      select_default,
      __spreadProps(__spreadValues({}, rest), {
        options,
        selectedOptions,
        onChange,
        multiple: true
      })
    );
  }
  return /* @__PURE__ */ React2.createElement(
    select_default,
    __spreadProps(__spreadValues({}, rest), {
      options,
      selectedOption: selectedOptions[0] || null,
      onChange
    })
  );
}
var select_default2 = memo2(RouteSelect);

// src/route/searchSelect.tsx
import React4, { memo as memo4 } from "react";

// src/searchSelect.tsx
import classNames2 from "classnames";
import React3, { Fragment as Fragment2, memo as memo3, useState } from "react";
import { Combobox, Transition as Transition2 } from "@headlessui/react";
import {
  CheckIcon as CheckIcon2,
  ChevronDownIcon as ChevronDownIcon2,
  XMarkIcon as XMarkIcon2,
  MagnifyingGlassIcon
} from "@heroicons/react/20/solid";
function SearchSelect({
  className,
  options,
  selectedOption,
  selectedOptions,
  onChange,
  multiple,
  placeholder,
  isLoading,
  filter,
  resetButton = true
}) {
  const [searchQuery, setSearchQuery] = useState("");
  const selectedValue = multiple ? selectedOptions : selectedOption;
  const selectedLabel = multiple ? selectedOptions == null ? void 0 : selectedOptions.map((x) => x.label).join(", ") : selectedOption == null ? void 0 : selectedOption.label;
  const searchString = searchQuery.toLowerCase().replace(/\s+/g, "");
  const currentOptions = searchQuery === "" ? options : options.filter(
    (x) => x.label.toLowerCase().replace(/\s+/g, "").includes(searchString)
  );
  return /* @__PURE__ */ React3.createElement(
    Combobox,
    {
      value: selectedValue || null,
      onChange,
      multiple,
      nullable: true,
      as: "div",
      className: classNames2("relative", className)
    },
    /* @__PURE__ */ React3.createElement(Combobox.Button, { as: "div" }, /* @__PURE__ */ React3.createElement(
      "button",
      {
        type: "button",
        className: classNames2(
          "relative form-control h-9 cursor-default py-2 pl-3 pr-10 text-left text-sm",
          filter ? "form-filter" : ""
        )
      },
      /* @__PURE__ */ React3.createElement(
        "span",
        {
          title: selectedLabel,
          className: classNames2(
            "block truncate",
            selectedLabel ? "" : "text-secondary-500"
          )
        },
        selectedLabel || placeholder
      ),
      (!resetButton || !selectedLabel) && /* @__PURE__ */ React3.createElement("span", { className: "pointer-events-none absolute inset-y-0 right-0 flex items-center pr-2" }, /* @__PURE__ */ React3.createElement(
        ChevronDownIcon2,
        {
          className: "h-5 w-5 text-secondary-500",
          "aria-hidden": "true"
        }
      ))
    )),
    resetButton && selectedLabel && /* @__PURE__ */ React3.createElement(
      "button",
      {
        type: "button",
        className: "absolute z-10 right-2.5 inset-y-0 my-2 px-0.5 rounded hover:bg-secondary-100 active:bg-secondary-200 focus:outline-none focus-visible:ring-2 focus-visible:ring-primary-500",
        onClick: () => {
          if (multiple) {
            onChange([]);
          } else {
            onChange(null);
          }
        }
      },
      /* @__PURE__ */ React3.createElement(
        XMarkIcon2,
        {
          className: "h-4 w-4 text-secondary-500",
          "aria-hidden": "true"
        }
      )
    ),
    /* @__PURE__ */ React3.createElement(
      Transition2,
      {
        as: Fragment2,
        leave: "transition ease-in duration-100",
        leaveFrom: "opacity-100",
        leaveTo: "opacity-0",
        afterLeave: () => {
          setSearchQuery("");
        }
      },
      /* @__PURE__ */ React3.createElement(Combobox.Options, { className: "absolute z-40 mt-1 w-full rounded-md bg-white py-1 shadow-lg ring-1 ring-black ring-opacity-5 focus:outline-none text-sm" }, !isLoading && /* @__PURE__ */ React3.createElement("div", { className: "relative" }, /* @__PURE__ */ React3.createElement(
        MagnifyingGlassIcon,
        {
          className: "pointer-events-none absolute top-3.5 left-4 h-5 w-5 text-secondary-400",
          "aria-hidden": "true"
        }
      ), /* @__PURE__ */ React3.createElement(
        Combobox.Input,
        {
          type: "search",
          placeholder: "Search...",
          className: "h-12 w-full bottom-0 border-transparent pl-11 pr-4 text-secondary-800 placeholder-secondary-400 text-sm focus:border-none focus:outline-none focus:ring-0 focus:shadow-none",
          displayValue: () => searchQuery,
          onChange: (event) => {
            setSearchQuery(event.target.value);
          }
        }
      )), currentOptions.length === 0 || isLoading ? /* @__PURE__ */ React3.createElement("div", { className: "relative cursor-default select-none py-2 px-4 text-secondary-700" }, isLoading ? "Loading..." : "No options") : /* @__PURE__ */ React3.createElement("div", { className: "overflow-auto max-h-60" }, currentOptions.map((option) => /* @__PURE__ */ React3.createElement(
        Combobox.Option,
        {
          key: option.value,
          className: ({ active }) => `relative cursor-default select-none py-2 pl-10 pr-4 ${active ? "bg-primary-100 text-primary-900" : "text-secondary-900"}`,
          value: option
        },
        ({ selected }) => /* @__PURE__ */ React3.createElement(React3.Fragment, null, /* @__PURE__ */ React3.createElement(
          "span",
          {
            className: `block truncate ${selected && selectedValue ? "font-medium" : "font-normal"}`
          },
          option.label
        ), selected && selectedValue ? /* @__PURE__ */ React3.createElement("span", { className: "absolute inset-y-0 left-0 flex items-center pl-3 text-primary-600" }, /* @__PURE__ */ React3.createElement(CheckIcon2, { className: "h-5 w-5", "aria-hidden": "true" })) : null)
      ))))
    )
  );
}
var searchSelect_default = memo3(SearchSelect);

// src/route/searchSelect.tsx
function RouteSearchSelect(_a) {
  var _b = _a, {
    options,
    filterName,
    emptyValue,
    multiple
  } = _b, rest = __objRest(_b, [
    "options",
    "filterName",
    "emptyValue",
    "multiple"
  ]);
  const { onChange, selectedOptions } = useRouteSelect(options, filterName, emptyValue);
  if (multiple) {
    return /* @__PURE__ */ React4.createElement(
      searchSelect_default,
      __spreadProps(__spreadValues({}, rest), {
        options,
        selectedOptions,
        onChange,
        multiple: true
      })
    );
  }
  return /* @__PURE__ */ React4.createElement(
    searchSelect_default,
    __spreadProps(__spreadValues({}, rest), {
      options,
      selectedOption: selectedOptions[0] || null,
      onChange
    })
  );
}
var searchSelect_default2 = memo4(RouteSearchSelect);

// src/combobox.tsx
import React5, { memo as memo5 } from "react";
function Combobox2(props) {
  if (props.options.length > 6) {
    return /* @__PURE__ */ React5.createElement(searchSelect_default, __spreadValues({}, props));
  }
  return /* @__PURE__ */ React5.createElement(select_default, __spreadValues({}, props));
}
var combobox_default = memo5(Combobox2);

// src/route/combobox.tsx
import React6, { memo as memo6 } from "react";
function RouteCombobox(props) {
  if (props.options.length > 6) {
    return /* @__PURE__ */ React6.createElement(searchSelect_default2, __spreadValues({}, props));
  }
  return /* @__PURE__ */ React6.createElement(select_default2, __spreadValues({}, props));
}
var combobox_default2 = memo6(RouteCombobox);

// src/route/autocomplete.tsx
import React8, { memo as memo8 } from "react";

// src/autocomplete.tsx
import classNames3 from "classnames";
import React7, { Fragment as Fragment3, memo as memo7 } from "react";
import { Combobox as Combobox3, Transition as Transition3 } from "@headlessui/react";
import { CheckIcon as CheckIcon3, XMarkIcon as XMarkIcon3 } from "@heroicons/react/20/solid";
function Autocomplete({
  className,
  options,
  selectedOption,
  onChange,
  placeholder,
  isLoading,
  filter,
  searchQuery,
  onSearch,
  minQueryLength = 2,
  resetButton = true
}) {
  const selectedValue = selectedOption;
  const selectedLabel = selectedOption == null ? void 0 : selectedOption.label;
  const emptyMessage = searchQuery.length < minQueryLength ? `Type at least ${minQueryLength} symbols` : "Nothing found";
  const showOptions = options.length > 0 && !isLoading && searchQuery.length >= minQueryLength;
  return /* @__PURE__ */ React7.createElement(
    Combobox3,
    {
      value: selectedValue,
      onChange,
      nullable: true,
      as: "div",
      className: classNames3("relative", className)
    },
    /* @__PURE__ */ React7.createElement(
      Combobox3.Input,
      {
        placeholder: selectedLabel || placeholder,
        className: classNames3(
          "relative form-control h-9 cursor-default py-2 pl-3 pr-10 text-left text-sm truncate",
          filter ? "form-filter" : "",
          selectedLabel ? "placeholder-secondary-800" : "placeholder-secondary-500"
        ),
        displayValue: () => searchQuery,
        onChange: ({ target }) => {
          const { value } = target;
          onSearch(value, value.length >= minQueryLength);
        }
      }
    ),
    resetButton && selectedValue && /* @__PURE__ */ React7.createElement(
      "button",
      {
        type: "button",
        className: "absolute z-10 right-2.5 inset-y-0 my-2 px-0.5 rounded hover:bg-secondary-100 active:bg-secondary-200 focus:outline-none focus-visible:ring-2 focus-visible:ring-primary-500",
        onClick: () => {
          onChange(null);
        }
      },
      /* @__PURE__ */ React7.createElement(
        XMarkIcon3,
        {
          className: "h-4 w-4 text-secondary-500",
          "aria-hidden": "true"
        }
      )
    ),
    /* @__PURE__ */ React7.createElement(
      Transition3,
      {
        as: Fragment3,
        leave: "transition ease-in duration-100",
        leaveFrom: "opacity-100",
        leaveTo: "opacity-0",
        afterLeave: () => {
          onSearch("", false);
        }
      },
      /* @__PURE__ */ React7.createElement(Combobox3.Options, { className: "absolute z-40 mt-1 w-full rounded-md bg-white py-1 shadow-lg ring-1 ring-black ring-opacity-5 focus:outline-none text-sm" }, !showOptions ? /* @__PURE__ */ React7.createElement("div", { className: "relative cursor-default select-none py-2 px-4 text-secondary-700" }, isLoading ? "Loading..." : emptyMessage) : /* @__PURE__ */ React7.createElement("div", { className: "overflow-auto max-h-60" }, options.map((option) => /* @__PURE__ */ React7.createElement(
        Combobox3.Option,
        {
          key: option.value,
          className: ({ active }) => `relative cursor-default select-none py-2 pl-10 pr-4 ${active ? "bg-primary-100 text-primary-900" : "text-secondary-900"}`,
          value: option
        },
        ({ selected }) => /* @__PURE__ */ React7.createElement(React7.Fragment, null, /* @__PURE__ */ React7.createElement(
          "span",
          {
            className: `block truncate ${selected && selectedValue ? "font-medium" : "font-normal"}`
          },
          option.label
        ), selected && selectedValue ? /* @__PURE__ */ React7.createElement("span", { className: "absolute inset-y-0 left-0 flex items-center pl-3 text-primary-600" }, /* @__PURE__ */ React7.createElement(CheckIcon3, { className: "h-5 w-5", "aria-hidden": "true" })) : null)
      ))))
    )
  );
}
var autocomplete_default = memo7(Autocomplete);

// src/route/autocomplete.tsx
function RouteAutocomplete(_a) {
  var _b = _a, { options, filterName, emptyValue } = _b, rest = __objRest(_b, ["options", "filterName", "emptyValue"]);
  const { onChange, selectedOptions } = useRouteSelect(options, filterName, emptyValue);
  return /* @__PURE__ */ React8.createElement(
    autocomplete_default,
    __spreadProps(__spreadValues({}, rest), {
      options,
      selectedOption: selectedOptions[0] || null,
      onChange
    })
  );
}
var autocomplete_default2 = memo8(RouteAutocomplete);

// src/route/index.tsx
var route_default = select_default2;
export {
  autocomplete_default as Autocomplete,
  combobox_default as Combobox,
  autocomplete_default2 as RouteAutocomplete,
  combobox_default2 as RouteCombobox,
  searchSelect_default2 as RouteSearchSelect,
  select_default2 as RouteSelect,
  searchSelect_default as SearchSelect,
  select_default as Select,
  route_default as default
};
